## nanomsg 0.4~beta+dfsg

=== CMakeLists.txt ===
#
#   Copyright (c) 2012 250bpm s.r.o.  All rights reserved.
#   Copyright (c) 2013 GoPivotal, Inc.  All rights reserved.
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom
#   the Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included
#   in all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
#   IN THE SOFTWARE.
#

cmake_minimum_required (VERSION 2.8)
include (CheckIncludeFiles)
include (CheckSymbolExists)
include (CheckCSourceCompiles)

project (nanomsg C)
enable_testing ()

#  Platform checks.

if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    add_definitions (-DNN_HAVE_WINDOWS)
    add_definitions (-D_CRT_SECURE_NO_WARNINGS)

    if (MINGW)
        add_definitions (-DNN_HAVE_MINGW -DNN_HAVE_STDINT -D_WIN32_WINNT=0x0600)
    endif ()
else ()
    message (FATAL_ERROR "ERROR: CMake build system is intended only to generate MSVC solution files.\nUse autotools build system for any other purpose." )
endif ()

#  Build the library itself.

add_subdirectory (src)

#  Build the tools

add_executable (nanocat tools/nanocat.c tools/options.c)
target_link_libraries (nanocat nanomsg)

#  Build unit tests.

set (all_tests "")

macro (add_libnanomsg_test NAME)
    list (APPEND all_tests ${NAME})
    add_executable (${NAME} tests/${NAME}.c)
    target_link_libraries (${NAME} nanomsg)
    add_test (NAME ${NAME} COMMAND ${NAME})
endmacro (add_libnanomsg_test)

#  Transport tests.
add_libnanomsg_test (inproc)
add_libnanomsg_test (inproc_shutdown)
add_libnanomsg_test (ipc)
add_libnanomsg_test (ipc_shutdown)
add_libnanomsg_test (tcp)
add_libnanomsg_test (tcp_shutdown)

#  Protocol tests.
add_libnanomsg_test (pair)
add_libnanomsg_test (pubsub)
add_libnanomsg_test (reqrep)
add_libnanomsg_test (pipeline)
add_libnanomsg_test (survey)
add_libnanomsg_test (bus)

#  Feature tests.
add_libnanomsg_test (block)
add_libnanomsg_test (term)
add_libnanomsg_test (timeo)
add_libnanomsg_test (iovec)
add_libnanomsg_test (msg)
add_libnanomsg_test (prio)
add_libnanomsg_test (poll)
add_libnanomsg_test (device)
add_libnanomsg_test (emfile)
add_libnanomsg_test (domain)
add_libnanomsg_test (trie)
add_libnanomsg_test (list)
add_libnanomsg_test (hash)
add_libnanomsg_test (symbol)
add_libnanomsg_test (separation)
add_libnanomsg_test (zerocopy)
add_libnanomsg_test (shutdown)

#  Build the performance tests.

macro (add_libnanomsg_perf NAME)
    add_executable (${NAME} perf/${NAME}.c)
    target_link_libraries (${NAME} nanomsg)
endmacro (add_libnanomsg_perf)

add_libnanomsg_perf (inproc_lat)
add_libnanomsg_perf (inproc_thr)
add_libnanomsg_perf (local_lat)
add_libnanomsg_perf (remote_lat)
add_libnanomsg_perf (local_thr)
add_libnanomsg_perf (remote_thr)

#  NSIS package

install (FILES src/nn.h DESTINATION include/nanomsg)
install (FILES src/inproc.h DESTINATION include/nanomsg)
install (FILES src/ipc.h DESTINATION include/nanomsg)
install (FILES src/tcp.h DESTINATION include/nanomsg)
install (FILES src/pair.h DESTINATION include/nanomsg)
install (FILES src/pubsub.h DESTINATION include/nanomsg)
install (FILES src/reqrep.h DESTINATION include/nanomsg)
install (FILES src/pipeline.h DESTINATION include/nanomsg)
install (FILES src/survey.h DESTINATION include/nanomsg)
install (FILES src/bus.h DESTINATION include/nanomsg)

install (TARGETS nanocat RUNTIME DESTINATION bin)

set (CPACK_GENERATOR "NSIS")
set (CPACK_PACKAGE_NAME "nanomsg")
include (CPack)

=== src/CMakeLists.txt ===
#
#   Copyright (c) 2012-2013 250bpm s.r.o.  All rights reserved.
#   Copyright (c) 2013 GoPivotal, Inc.  All rights reserved.
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom
#   the Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included
#   in all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
#   IN THE SOFTWARE.
#

set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

set (NN_SOURCES
    nn.h
    inproc.h
    ipc.h
    tcp.h
    pair.h
    pubsub.h
    reqrep.h
    pipeline.h
    survey.h
    bus.h

    core/ep.h
    core/ep.c
    core/epbase.c
    core/global.h
    core/global.c
    core/pipe.c
    core/poll.c
    core/sock.h
    core/sock.c
    core/sockbase.c
    core/device.c
    core/symbol.c

    aio/ctx.h
    aio/ctx.c
    aio/fsm.h
    aio/fsm.c
    aio/poller.h
    aio/poller.c
    aio/poller_epoll.h
    aio/poller_epoll.inc
    aio/poller_kqueue.h
    aio/poller_kqueue.inc
    aio/poller_poll.h
    aio/poller_poll.inc
    aio/pool.h
    aio/pool.c
    aio/timer.h
    aio/timer.c
    aio/timerset.h
    aio/timerset.c
    aio/usock.h
    aio/usock.c
    aio/usock_posix.h
    aio/usock_posix.inc
    aio/usock_win.h
    aio/usock_win.inc
    aio/worker.h
    aio/worker.c
    aio/worker_posix.h
    aio/worker_posix.inc
    aio/worker_win.h
    aio/worker_win.inc

    utils/alloc.h
    utils/alloc.c
    utils/atomic.h
    utils/atomic.c
    utils/attr.h
    utils/chunk.h
    utils/chunk.c
    utils/chunkref.h
    utils/chunkref.c
    utils/clock.h
    utils/clock.c
    utils/closefd.h
    utils/closefd.c
    utils/cont.h
    utils/efd.h
    utils/efd.c
    utils/efd_eventfd.h
    utils/efd_eventfd.inc
    utils/efd_pipe.h
    utils/efd_pipe.inc
    utils/efd_socketpair.h
    utils/efd_socketpair.inc
    utils/efd_win.h
    utils/efd_win.inc
    utils/err.h
    utils/err.c
    utils/fast.h
    utils/fd.h
    utils/glock.h
    utils/glock.c
    utils/hash.h
    utils/hash.c
    utils/int.h
    utils/list.h
    utils/list.c
    utils/msg.h
    utils/msg.c
    utils/mutex.h
    utils/mutex.c
    utils/queue.h
    utils/queue.c
    utils/random.h
    utils/random.c
    utils/sem.h
    utils/sem.c
    utils/sleep.h
    utils/sleep.c
    utils/thread.h
    utils/thread.c
    utils/thread_posix.h
    utils/thread_posix.inc
    utils/thread_win.h
    utils/thread_win.inc
    utils/wire.h
    utils/wire.c

    protocols/utils/dist.h
    protocols/utils/dist.c
    protocols/utils/excl.h
    protocols/utils/excl.c
    protocols/utils/fq.h
    protocols/utils/fq.c
    protocols/utils/lb.h
    protocols/utils/lb.c
    protocols/utils/priolist.h
    protocols/utils/priolist.c

    protocols/bus/bus.h
    protocols/bus/bus.c
    protocols/bus/xbus.h
    protocols/bus/xbus.c

    protocols/pipeline/push.h
    protocols/pipeline/push.c
    protocols/pipeline/pull.h
    protocols/pipeline/pull.c
    protocols/pipeline/xpull.h
    protocols/pipeline/xpull.c
    protocols/pipeline/xpush.h
    protocols/pipeline/xpush.c

    protocols/pair/pair.h
    protocols/pair/pair.c
    protocols/pair/xpair.h
    protocols/pair/xpair.c

    protocols/pubsub/pub.h
    protocols/pubsub/pub.c
    protocols/pubsub/sub.h
    protocols/pubsub/sub.c
    protocols/pubsub/trie.h
    protocols/pubsub/trie.c
    protocols/pubsub/xpub.h
    protocols/pubsub/xpub.c
    protocols/pubsub/xsub.h
    protocols/pubsub/xsub.c

    protocols/reqrep/req.h
    protocols/reqrep/req.c
    protocols/reqrep/rep.h
    protocols/reqrep/rep.c
    protocols/reqrep/xrep.h
    protocols/reqrep/xrep.c
    protocols/reqrep/xreq.h
    protocols/reqrep/xreq.c

    protocols/survey/respondent.h
    protocols/survey/respondent.c
    protocols/survey/surveyor.h
    protocols/survey/surveyor.c
    protocols/survey/xrespondent.h
    protocols/survey/xrespondent.c
    protocols/survey/xsurveyor.h
    protocols/survey/xsurveyor.c

    transports/utils/backoff.h
    transports/utils/backoff.c
    transports/utils/dns.h
    transports/utils/dns.c
    transports/utils/dns_getaddrinfo.h
    transports/utils/dns_getaddrinfo.inc
    transports/utils/dns_getaddrinfo_a.h
    transports/utils/dns_getaddrinfo_a.inc
    transports/utils/iface.h
    transports/utils/iface.c
    transports/utils/literal.h
    transports/utils/literal.c
    transports/utils/port.h
    transports/utils/port.c
    transports/utils/streamhdr.h
    transports/utils/streamhdr.c

    transports/inproc/binproc.h
    transports/inproc/binproc.c
    transports/inproc/cinproc.h
    transports/inproc/cinproc.c
    transports/inproc/inproc.h
    transports/inproc/inproc.c
    transports/inproc/ins.h
    transports/inproc/ins.c
    transports/inproc/msgqueue.h
    transports/inproc/msgqueue.c
    transports/inproc/sinproc.h
    transports/inproc/sinproc.c

    transports/ipc/aipc.h
    transports/ipc/aipc.c
    transports/ipc/bipc.h
    transports/ipc/bipc.c
    transports/ipc/cipc.h
    transports/ipc/cipc.c
    transports/ipc/ipc.h
    transports/ipc/ipc.c
    transports/ipc/sipc.h
    transports/ipc/sipc.c

    transports/tcp/atcp.h
    transports/tcp/atcp.c
    transports/tcp/btcp.h
    transports/tcp/btcp.c
    transports/tcp/ctcp.h
    transports/tcp/ctcp.c
    transports/tcp/stcp.h
    transports/tcp/stcp.c
    transports/tcp/tcp.h
    transports/tcp/tcp.c
)

if (WIN32)
    LIST (APPEND NN_SOURCES
        utils/win.h
    )
endif ()

add_library (nanomsg SHARED ${NN_SOURCES})

add_definitions (-DNN_EXPORTS)
add_definitions (-DNN_USE_LITERAL_IFADDR)

target_link_libraries (nanomsg ws2_32)
target_link_libraries (nanomsg Mswsock.lib)
target_link_libraries (nanomsg Advapi32.lib)

install(TARGETS nanomsg
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin)

=== debian/changelog ===
nanomsg (0.4~beta+dfsg-3) unstable; urgency=medium

  * Add the debug package.

 -- Harlan Lieberman-Berg <H.LiebermanBerg@gmail.com>  Tue, 26 Aug 2014 14:15:20 -0700

nanomsg (0.4~beta+dfsg-2) unstable; urgency=medium

  * Disable test due to transient failure (Closes: #759129)

 -- Harlan Lieberman-Berg <H.LiebermanBerg@gmail.com>  Sun, 24 Aug 2014 15:57:02 -0700

nanomsg (0.4~beta+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #753895)

 -- Harlan Lieberman-Berg <H.LiebermanBerg@gmail.com>  Fri, 27 Jun 2014 12:23:49 -0400

=== debian/control ===
Source: nanomsg
Priority: extra
Section: libs
Maintainer: Harlan Lieberman-Berg <H.LiebermanBerg@gmail.com>
Build-Depends: debhelper (>= 9.0.0), dh-autoreconf
Standards-Version: 3.9.5
Homepage: http://nanomsg.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/nanomsg.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/nanomsg.git

Package: libnanomsg-dev
Section: libdevel
Architecture: any
Depends: libnanomsg0 (= ${binary:Version}), ${misc:Depends}
Description: nanomsg development files
 nanomsg is a socket library that provides several common
 communication patterns. It aims to make the networking layer fast,
 scalable, and easy to use. Implemented in C, it works on a wide range
 of operating systems with no further dependencies.
 .
 The communication patterns, also called "scalability protocols", are
 basic blocks for building distributed systems. By combining them you
 can create a vast array of distributed applications. The following
 scalability protocols are currently available:
 .
    PAIR - simple one-to-one communication
    BUS - simple many-to-many communication
    REQREP - allows one to build clusters of stateless services
             to process user requests
    PUBSUB - distributes messages to large sets of interested subscribers
    PIPELINE - aggregates messages from multiple sources and 
               load balances them among many destinations
    SURVEY - allows one to query state of multiple applications in a single go
 .
 This package contains the development files for nanomsg.

Package: libnanomsg0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high-performance implementation of scalability libraries
 nanomsg is a socket library that provides several common
 communication patterns. It aims to make the networking layer fast,
 scalable, and easy to use. Implemented in C, it works on a wide range
 of operating systems with no further dependencies.
 .
 The communication patterns, also called "scalability protocols", are
 basic blocks for building distributed systems. By combining them you
 can create a vast array of distributed applications. The following
 scalability protocols are currently available:
 .
    PAIR - simple one-to-one communication
    BUS - simple many-to-many communication
    REQREP - allows one to build clusters of stateless services
             to process user requests
    PUBSUB - distributes messages to large sets of interested subscribers
    PIPELINE - aggregates messages from multiple sources and 
               load balances them among many destinations
    SURVEY - allows one to query state of multiple applications in a single go 

Package: libnanomsg0-dbg
Section: debug
Architecture: any
Depends: libnanomsg0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: high-performance implementation of scalability libraries - debug symbols
 nanomsg is a socket library that provides several common
 communication patterns. It aims to make the networking layer fast,
 scalable, and easy to use. Implemented in C, it works on a wide range
 of operating systems with no further dependencies.
 .
 The communication patterns, also called "scalability protocols", are
 basic blocks for building distributed systems. By combining them you
 can create a vast array of distributed applications. The following
 scalability protocols are currently available:
 .
    PAIR - simple one-to-one communication
    BUS - simple many-to-many communication
    REQREP - allows one to build clusters of stateless services
             to process user requests
    PUBSUB - distributes messages to large sets of interested subscribers
    PIPELINE - aggregates messages from multiple sources and 
               load balances them among many destinations
    SURVEY - allows one to query state of multiple applications in a single go 
 .
 This package contains the debug symbols for libnanomsg.

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg//,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/nanomsg_$1\+dfsg\.orig\.tar\.gz/ \
  https://github.com/nanomsg/nanomsg/tags .*/v?(\d\S*)\.tar\.gz

## nanomsg 0.5~beta%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: libs
 Maintainer: Harlan Lieberman-Berg <H.LiebermanBerg@gmail.com>
 Build-Depends: debhelper (>= 9.0.0), dh-autoreconf
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://nanomsg.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/nanomsg.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/nanomsg.git
@@ -28,7 +28,7 @@
     REQREP - allows one to build clusters of stateless services
              to process user requests
     PUBSUB - distributes messages to large sets of interested subscribers
-    PIPELINE - aggregates messages from multiple sources and 
+    PIPELINE - aggregates messages from multiple sources and
                load balances them among many destinations
     SURVEY - allows one to query state of multiple applications in a single go
  .
@@ -36,7 +36,7 @@
 
 Package: libnanomsg0
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: high-performance implementation of scalability libraries
  nanomsg is a socket library that provides several common
  communication patterns. It aims to make the networking layer fast,
@@ -53,14 +53,14 @@
     REQREP - allows one to build clusters of stateless services
              to process user requests
     PUBSUB - distributes messages to large sets of interested subscribers
-    PIPELINE - aggregates messages from multiple sources and 
+    PIPELINE - aggregates messages from multiple sources and
                load balances them among many destinations
-    SURVEY - allows one to query state of multiple applications in a single go 
+    SURVEY - allows one to query state of multiple applications in a single go
 
 Package: libnanomsg0-dbg
 Section: debug
 Architecture: any
-Depends: libnanomsg0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libnanomsg0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: high-performance implementation of scalability libraries - debug symbols
  nanomsg is a socket library that provides several common
  communication patterns. It aims to make the networking layer fast,
@@ -77,8 +77,8 @@
     REQREP - allows one to build clusters of stateless services
              to process user requests
     PUBSUB - distributes messages to large sets of interested subscribers
-    PIPELINE - aggregates messages from multiple sources and 
+    PIPELINE - aggregates messages from multiple sources and
                load balances them among many destinations
-    SURVEY - allows one to query state of multiple applications in a single go 
+    SURVEY - allows one to query state of multiple applications in a single go
  .
  This package contains the debug symbols for libnanomsg.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autoreconf --parallel
override_dh_strip:
	dh_strip --dbg-package=libnanomsg0-dbg

## nanomsg 0.5~beta+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-#   Copyright (c) 2012 250bpm s.r.o.  All rights reserved.
+#   Copyright (c) 2012 Martin Sustrik  All rights reserved.
 #   Copyright (c) 2013 GoPivotal, Inc.  All rights reserved.
 #
 #   Permission is hereby granted, free of charge, to any person obtaining a copy
@@ -67,6 +67,7 @@
 add_libnanomsg_test (inproc_shutdown)
 add_libnanomsg_test (ipc)
 add_libnanomsg_test (ipc_shutdown)
+add_libnanomsg_test (ipc_stress)
 add_libnanomsg_test (tcp)
 add_libnanomsg_test (tcp_shutdown)
 
@@ -96,6 +97,7 @@
 add_libnanomsg_test (separation)
 add_libnanomsg_test (zerocopy)
 add_libnanomsg_test (shutdown)
+add_libnanomsg_test (cmsg)
 
 #  Build the performance tests.

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-#   Copyright (c) 2012-2013 250bpm s.r.o.  All rights reserved.
+#   Copyright (c) 2012-2013 Martin Sustrik  All rights reserved.
 #   Copyright (c) 2013 GoPivotal, Inc.  All rights reserved.
 #
 #   Permission is hereby granted, free of charge, to any person obtaining a copy
@@ -47,7 +47,6 @@
     core/sock.h
     core/sock.c
     core/sockbase.c
-    core/device.c
     core/symbol.c
 
     aio/ctx.h
@@ -137,6 +136,9 @@
     utils/wire.h
     utils/wire.c
 
+    devices/device.h
+    devices/device.c
+
     protocols/utils/dist.h
     protocols/utils/dist.c
     protocols/utils/excl.h
@@ -182,6 +184,8 @@
     protocols/reqrep/req.c
     protocols/reqrep/rep.h
     protocols/reqrep/rep.c
+    protocols/reqrep/task.h
+    protocols/reqrep/task.c
     protocols/reqrep/xrep.h
     protocols/reqrep/xrep.c
     protocols/reqrep/xreq.h

=== debian/changelog ===
nanomsg (0.5~beta+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Harlan Lieberman-Berg <H.LiebermanBerg@gmail.com>  Tue, 28 Apr 2015 13:17:01 -0400

nanomsg (0.4~beta+dfsg-4) unstable; urgency=medium

  * Cherry-pick patch off of nanomsg master
    to prevent FTBFS on sparc. (Closes: #759129)
  * Clean up test files after creation. (Closes: #766652)

 -- Harlan Lieberman-Berg <H.LiebermanBerg@gmail.com>  Fri, 24 Oct 2014 11:41:51 -0400

## nanomsg 0.8~beta+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,6 +60,7 @@
     add_executable (${NAME} tests/${NAME}.c)
     target_link_libraries (${NAME} nanomsg)
     add_test (NAME ${NAME} COMMAND ${NAME})
+    set_tests_properties (${NAME} PROPERTIES  TIMEOUT 30)
 endmacro (add_libnanomsg_test)
 
 #  Transport tests.
@@ -70,6 +71,8 @@
 add_libnanomsg_test (ipc_stress)
 add_libnanomsg_test (tcp)
 add_libnanomsg_test (tcp_shutdown)
+add_libnanomsg_test (ws)
+add_libnanomsg_test (tcpmux)
 
 #  Protocol tests.
 add_libnanomsg_test (pair)
@@ -80,6 +83,7 @@
 add_libnanomsg_test (bus)
 
 #  Feature tests.
+add_libnanomsg_test (async_shutdown)
 add_libnanomsg_test (block)
 add_libnanomsg_test (term)
 add_libnanomsg_test (timeo)
@@ -88,6 +92,8 @@
 add_libnanomsg_test (prio)
 add_libnanomsg_test (poll)
 add_libnanomsg_test (device)
+add_libnanomsg_test (device4)
+add_libnanomsg_test (device5)
 add_libnanomsg_test (emfile)
 add_libnanomsg_test (domain)
 add_libnanomsg_test (trie)
@@ -98,6 +104,7 @@
 add_libnanomsg_test (zerocopy)
 add_libnanomsg_test (shutdown)
 add_libnanomsg_test (cmsg)
+add_libnanomsg_test (bug328)
 
 #  Build the performance tests.
 
@@ -119,6 +126,7 @@
 install (FILES src/inproc.h DESTINATION include/nanomsg)
 install (FILES src/ipc.h DESTINATION include/nanomsg)
 install (FILES src/tcp.h DESTINATION include/nanomsg)
+install (FILES src/ws.h DESTINATION include/nanomsg)
 install (FILES src/pair.h DESTINATION include/nanomsg)
 install (FILES src/pubsub.h DESTINATION include/nanomsg)
 install (FILES src/reqrep.h DESTINATION include/nanomsg)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,7 @@
     inproc.h
     ipc.h
     tcp.h
+    ws.h
     pair.h
     pubsub.h
     reqrep.h
@@ -138,6 +139,7 @@
 
     devices/device.h
     devices/device.c
+    devices/tcpmuxd.c
 
     protocols/utils/dist.h
     protocols/utils/dist.c
@@ -216,6 +218,8 @@
     transports/utils/port.c
     transports/utils/streamhdr.h
     transports/utils/streamhdr.c
+    transports/utils/base64.h
+    transports/utils/base64.c
 
     transports/inproc/binproc.h
     transports/inproc/binproc.c
@@ -251,6 +255,32 @@
     transports/tcp/stcp.c
     transports/tcp/tcp.h
     transports/tcp/tcp.c
+
+    transports/tcpmux/atcpmux.h
+    transports/tcpmux/atcpmux.c
+    transports/tcpmux/btcpmux.h
+    transports/tcpmux/btcpmux.c
+    transports/tcpmux/ctcpmux.h
+    transports/tcpmux/ctcpmux.c
+    transports/tcpmux/stcpmux.h
+    transports/tcpmux/stcpmux.c
+    transports/tcpmux/tcpmux.h
+    transports/tcpmux/tcpmux.c
+
+    transports/ws/aws.h
+    transports/ws/aws.c
+    transports/ws/bws.h
+    transports/ws/bws.c
+    transports/ws/cws.h
+    transports/ws/cws.c
+    transports/ws/sws.h
+    transports/ws/sws.c
+    transports/ws/ws.h
+    transports/ws/ws.c
+    transports/ws/ws_handshake.h
+    transports/ws/ws_handshake.c
+    transports/ws/sha1.h
+    transports/ws/sha1.c
 )
 
 if (WIN32)
@@ -262,11 +292,10 @@
 add_library (nanomsg SHARED ${NN_SOURCES})
 
 add_definitions (-DNN_EXPORTS)
-add_definitions (-DNN_USE_LITERAL_IFADDR)
 
 target_link_libraries (nanomsg ws2_32)
-target_link_libraries (nanomsg Mswsock.lib)
-target_link_libraries (nanomsg Advapi32.lib)
+target_link_libraries (nanomsg mswsock)
+target_link_libraries (nanomsg advapi32)
 
 install(TARGETS nanomsg
     ARCHIVE DESTINATION lib

=== debian/changelog ===
nanomsg (0.8~beta+dfsg-1) unstable; urgency=medium

  * New upstream version, with new soversion.
  * Add updated copyrights to d/copyright.
  * Bump priority to optional for policy 2.5.
  * Stop building -dbg packages no longer needed.
  * Remove patches obsoleted or integrated upstream.
  * New watchfile.
  * Rebuild d/copyright.
  * Change my email address.
  * Build nanocat, tcpmuxd.  (Closes: #777676)
  * Ensure tests run in sequence.  (Closes: #805702)
  * Bump standards version; no changes needed.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sun, 24 Apr 2016 23:37:44 -0400

=== debian/control ===
Source: nanomsg
Priority: optional
Section: libs
Maintainer: Harlan Lieberman-Berg <hlieberman@debian.org>
Build-Depends: asciidoc,
               debhelper (>= 9.0.0),
               dh-autoreconf,
               libxml2-utils,
               xmlto
Standards-Version: 3.9.7
Homepage: http://nanomsg.org/
Vcs-Git: https://anonscm.debian.org/collab-maint/nanomsg.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/nanomsg.git

Package: libnanomsg-dev
Section: libdevel
Architecture: any
Depends: libnanomsg4 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: nanomsg development files
 nanomsg is a socket library that provides several common
 communication patterns. It aims to make the networking layer fast,
 scalable, and easy to use. Implemented in C, it works on a wide range
 of operating systems with no further dependencies.
 .
 The communication patterns, also called "scalability protocols", are
 basic blocks for building distributed systems. By combining them you
 can create a vast array of distributed applications. The following
 scalability protocols are currently available:
 .
    PAIR - simple one-to-one communication
    BUS - simple many-to-many communication
    REQREP - allows one to build clusters of stateless services
             to process user requests
    PUBSUB - distributes messages to large sets of interested subscribers
    PIPELINE - aggregates messages from multiple sources and
               load balances them among many destinations
    SURVEY - allows one to query state of multiple applications in a single go
 .
 This package contains the development files for nanomsg.

Package: nanomsg-utils
Architecture: any
Depends: libnanomsg4 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: nanomsg utilities
 nanomsg is a socket library that provides several common
 communication patterns. It aims to make the networking layer fast,
 scalable, and easy to use. Implemented in C, it works on a wide range
 of operating systems with no further dependencies.
 .
 The communication patterns, also called "scalability protocols", are
 basic blocks for building distributed systems. By combining them you
 can create a vast array of distributed applications. The following
 scalability protocols are currently available:
 .
    PAIR - simple one-to-one communication
    BUS - simple many-to-many communication
    REQREP - allows one to build clusters of stateless services
             to process user requests
    PUBSUB - distributes messages to large sets of interested subscribers
    PIPELINE - aggregates messages from multiple sources and
               load balances them among many destinations
    SURVEY - allows one to query state of multiple applications in a single go
 .
 This package contains utilities for testing nanomsg.

Package: libnanomsg4
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: high-performance implementation of scalability libraries
 nanomsg is a socket library that provides several common
 communication patterns. It aims to make the networking layer fast,
 scalable, and easy to use. Implemented in C, it works on a wide range
 of operating systems with no further dependencies.
 .
 The communication patterns, also called "scalability protocols", are
 basic blocks for building distributed systems. By combining them you
 can create a vast array of distributed applications. The following
 scalability protocols are currently available:
 .
    PAIR - simple one-to-one communication
    BUS - simple many-to-many communication
    REQREP - allows one to build clusters of stateless services
             to process user requests
    PUBSUB - distributes messages to large sets of interested subscribers
    PIPELINE - aggregates messages from multiple sources and
               load balances them among many destinations
    SURVEY - allows one to query state of multiple applications in a single go

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autoreconf --parallel

override_dh_auto_build:
	dh_auto_build
	a2x -f manpage $(CURDIR)/doc/nanocat.txt
	a2x -f manpage $(CURDIR)/doc/tcpmuxd.txt

override_dh_auto_test:
	dh_auto_test --no-parallel

=== debian/watch ===
version=3
opts=uversionmangle=s/-beta/~beta+dfsg/,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$// \
  https://github.com/nanomsg/nanomsg/releases .*/nanomsg-(\d\S*)\.tar\.gz

## nanomsg 1.1.5%2Bdfsg

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
%:
	dh $@ --buildsystem=cmake
